package dev.shadowsoffire.apotheosis.village.fletching;

import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.SimpleMenuProvider;
import net.minecraft.world.MenuProvider;
import net.minecraft.world.InteractionResult;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.InteractionHand;
import net.minecraft.world.entity.player.Player;
import net.minecraft.core.BlockPos;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.SoundType;
import net.minecraft.world.level.material.MapColor;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.network.chat.Component;
import dev.shadowsoffire.placebo.util.IReplacementBlock;
import net.minecraft.world.level.block.FletchingTableBlock;

public class ApothFletchingBlock extends FletchingTableBlock implements IReplacementBlock
{
    public static final Component NAME;
    protected StateDefinition<Block, BlockState> container;
    
    public ApothFletchingBlock() {
        super(BlockBehaviour.Properties.m_284310_().m_284180_(MapColor.f_283825_).m_278183_().m_60978_(2.5f).m_60918_(SoundType.f_56736_));
    }
    
    public InteractionResult m_6227_(final BlockState state, final Level worldIn, final BlockPos pos, final Player player, final InteractionHand handIn, final BlockHitResult hit) {
        if (worldIn.f_46443_) {
            return InteractionResult.SUCCESS;
        }
        player.m_5893_(this.m_7246_(state, worldIn, pos));
        return InteractionResult.CONSUME;
    }
    
    public MenuProvider m_7246_(final BlockState state, final Level world, final BlockPos pos) {
        return What.getMenuProvider(state, world, pos);
    }
    
    public void _setDefaultState(final BlockState state) {
        this.m_49959_(state);
    }
    
    public void setStateContainer(final StateDefinition<Block, BlockState> container) {
        this.container = container;
    }
    
    public StateDefinition<Block, BlockState> m_49965_() {
        return (StateDefinition<Block, BlockState>)((this.container == null) ? super.m_49965_() : this.container);
    }
    
    static {
        NAME = (Component)Component.m_237115_("apotheosis.recipes.fletching");
    }
    
    private static class What
    {
        static MenuProvider getMenuProvider(final BlockState state, final Level world, final BlockPos pos) {
            return (MenuProvider)new SimpleMenuProvider((id, inv, player) -> new FletchingContainer(id, inv, world, pos), ApothFletchingBlock.NAME);
        }
    }
}
